diff --git a/src/zabbix_server/vmware/vmware.c b/src/zabbix_server/vmware/vmware.c
index 43dd9835e99..3379b506ac1 100644
--- a/src/zabbix_server/vmware/vmware.c
+++ b/src/zabbix_server/vmware/vmware.c
@@ -61,6 +61,8 @@ extern zbx_uint64_t	CONFIG_VMWARE_CACHE_SIZE;
 extern int		CONFIG_VMWARE_TIMEOUT;
 extern char		*CONFIG_SOURCE_IP;
 
+#define zbx_strscat(x, y)	zbx_strlcat(x, y, sizeof(x))
+
 #define VMWARE_VECTOR_CREATE(ref, type)	zbx_vector_##type##_create_ext(ref,  __vm_shmem_malloc_func, \
 		__vm_shmem_realloc_func, __vm_shmem_free_func)
 
@@ -99,6 +101,7 @@ ZBX_PTR_VECTOR_IMPL(vmware_custom_attr, zbx_vmware_custom_attr_t *)
 ZBX_PTR_VECTOR_IMPL(custquery_param, zbx_vmware_custquery_param_t)
 ZBX_PTR_VECTOR_IMPL(vmware_dvswitch, zbx_vmware_dvswitch_t *)
 ZBX_PTR_VECTOR_IMPL(vmware_alarm, zbx_vmware_alarm_t *)
+ZBX_PTR_VECTOR_IMPL(vmware_diskinfo, zbx_vmware_diskinfo_t *)
 
 /* VMware service object name mapping for vcenter and vsphere installations */
 typedef struct
@@ -148,8 +151,8 @@ typedef struct
 }
 zbx_vmware_cq_value_t;
 
-ZBX_PTR_VECTOR_DECL(cq_value, zbx_vmware_cq_value_t)
-ZBX_PTR_VECTOR_IMPL(cq_value, zbx_vmware_cq_value_t)
+ZBX_PTR_VECTOR_DECL(cq_value, zbx_vmware_cq_value_t *)
+ZBX_PTR_VECTOR_IMPL(cq_value, zbx_vmware_cq_value_t *)
 
 /* performance data for a performance collector entity */
 typedef struct
@@ -194,6 +197,7 @@ typedef struct
 	int	enabled;
 }
 zbx_vmware_alarm_details_t;
+
 ZBX_PTR_VECTOR_DECL(vmware_alarm_details, zbx_vmware_alarm_details_t *)
 ZBX_PTR_VECTOR_IMPL(vmware_alarm_details, zbx_vmware_alarm_details_t *)
 
@@ -204,6 +208,21 @@ typedef struct
 }
 zbx_vmware_alarms_data_t;
 
+/* VMware performance counters available per object (information cache) */
+ZBX_VECTOR_DECL(uint16, uint16_t)
+ZBX_VECTOR_IMPL(uint16, uint16_t)
+
+typedef struct
+{
+	char			*type;
+	char			*id;
+	zbx_vector_uint16_t	list;
+}
+zbx_vmware_perf_available_t;
+
+ZBX_PTR_VECTOR_DECL(perf_available, zbx_vmware_perf_available_t *)
+ZBX_PTR_VECTOR_IMPL(perf_available, zbx_vmware_perf_available_t *)
+
 #define ZBX_HOSTINFO_NODES_DATACENTER		0x01
 #define ZBX_HOSTINFO_NODES_COMPRES		0x02
 #define ZBX_HOSTINFO_NODES_HOST			0x04
@@ -249,8 +268,10 @@ static zbx_uint64_t	evt_req_chunk_size;
 
 #define ZBX_XPATH_FAULT_SLOW(max_len)									\
 	"concat(substring(" ZBX_XPATH_FAULT_FAST("faultstring")",1," ZBX_STR(max_len) "),"		\
-	"substring(local-name(" ZBX_XPATH_FAULT_FAST("detail") "/*[1]"					\
-	"),1," ZBX_STR(max_len) " * number(string-length(" ZBX_XPATH_FAULT_FAST("faultstring") ")=0)))"
+	"substring(concat(local-name(" ZBX_XPATH_FAULT_FAST("detail") "/*[1]),':',"			\
+	ZBX_XPATH_FAULT_FAST("detail")"//*[local-name()='name']),1,"					\
+	ZBX_STR(max_len) " * number(string-length(" ZBX_XPATH_FAULT_FAST("faultstring") ")=0)"		\
+	"* number(string-length(local-name(" ZBX_XPATH_FAULT_FAST("detail") "/*[1]) )>0)))"
 
 #define ZBX_XPATH_REFRESHRATE()										\
 	"/*/*/*/*/*[local-name()='refreshRate' and ../*[local-name()='currentSupported']='true']"
@@ -319,10 +340,6 @@ static zbx_uint64_t	evt_req_chunk_size;
 		"/*[local-name()='val']/*[local-name()='adapter']/*[local-name()='target']"		\
 		"/*[local-name()='lun']/*[local-name()='scsiLun']"
 
-#define ZBX_XPATH_HV_LUN()										\
-		"substring-before(substring-after(/*/*/*/*/*/*[local-name()='propSet']"			\
-		"[*[local-name()='val'][text()='%s']][1]/*[local-name()='name'],'\"'),'\"')"
-
 #define ZBX_XPATH_HV_MULTIPATH(state)									\
 		"count(/*/*/*/*/*/*[local-name()='propSet'][1]/*[local-name()='val']"			\
 		"/*[local-name()='lun'][*[local-name()='lun'][text()='%s']][1]"				\
@@ -369,9 +386,10 @@ static zbx_uint64_t	evt_req_chunk_size;
 
 typedef int	(*nodeprocfunc_t)(void *, char **);
 static int	vmware_service_get_vm_snapshot(void *xml_node, char **jstr);
-static void	vmware_service_cq_prop_value(const char *fn_parent, xmlDoc *xdoc, zbx_vmware_cq_value_t *cqv);
+static void	vmware_service_cq_prop_value(const char *fn_parent, xmlDoc *xdoc, zbx_vector_cq_value_t *cqvs);
 static char	*vmware_cq_prop_soap_request(const zbx_vector_cq_value_t *cq_values, const char *soap_type,
-		const char *clusterid, const size_t bsz, char *buff, zbx_vmware_cq_value_t **cq_prop);
+		const char *obj_id, zbx_vector_cq_value_t *cqvs);
+static int	vmware_diskinfo_diskname_compare(const void *d1, const void *d2);
 
 typedef struct
 {
@@ -410,7 +428,7 @@ static zbx_vmware_propmap_t	hv_propmap[] = {
 	ZBX_HVPROPMAP("runtime.connectionState"),		/* ZBX_VMWARE_HVPROP_CONNECTIONSTATE */
 	ZBX_HVPROPMAP_EXT("hardware.systemInfo.serialNumber", NULL, 67),/* ZBX_VMWARE_HVPROP_HW_SERIALNUMBER */
 	ZBX_HVPROPMAP_EXT("runtime.healthSystemRuntime.hardwareStatusInfo",
-			zbx_xmlnode_to_json, 0),		/* ZBX_VMWARE_HVPROP_HW_SENSOR */
+			zbx_xmlnode_to_json, 0)			/* ZBX_VMWARE_HVPROP_HW_SENSOR */
 };
 
 static zbx_vmware_propmap_t	vm_propmap[] = {
@@ -450,6 +468,9 @@ static zbx_vmware_propmap_t	vm_propmap[] = {
 #define ZBX_XPATH_OBJECTS_BY_TYPE(type)									\
 	"/*/*/*/*/*[local-name()='objects'][*[local-name()='obj'][@type='" type "']]"
 
+#define ZBX_XPATH_OBJS_BY_TYPE(type)									\
+	"/*/*/*/*/*[local-name()='objects']/*[local-name()='obj'][@type='" type "']"
+
 #define ZBX_XPATH_NAME_BY_TYPE(type)									\
 	ZBX_XPATH_PROP_OBJECT(type) "*[local-name()='propSet'][*[local-name()='name']]"			\
 	"/*[local-name()='val']"
@@ -674,9 +695,10 @@ int	zbx_str_uint64_pair_name_compare(const void *p1, const void *p2)
  * Parameters: cq_value - [IN] the custom query value data                    *
  *                                                                            *
  ******************************************************************************/
-static void	zbx_vmware_cq_value_free(zbx_vmware_cq_value_t cq_value)
+static void	zbx_vmware_cq_value_free(zbx_vmware_cq_value_t *cq_value)
 {
-	zbx_free(cq_value.response);
+	zbx_str_free(cq_value->response);
+	zbx_free(cq_value);
 }
 
 /******************************************************************************
@@ -857,6 +879,43 @@ static int	vmware_perf_entity_compare_func(const void *d1, const void *d2)
 	return ret;
 }
 
+/******************************************************************************
+ *                                                                            *
+ * performance counter availability list support functions                    *
+ *                                                                            *
+ ******************************************************************************/
+static int	vmware_perf_available_compare(const void *d1, const void *d2)
+{
+	int	ret;
+
+	const zbx_vmware_perf_available_t	*e1 = *(const zbx_vmware_perf_available_t * const *)d1;
+	const zbx_vmware_perf_available_t	*e2 = *(const zbx_vmware_perf_available_t * const *)d2;
+
+	if (0 == (ret = strcmp(e1->type, e2->type)))
+		ret = strcmp(e1->id, e2->id);
+
+	return ret;
+}
+
+static void	vmware_perf_available_free(zbx_vmware_perf_available_t *value)
+{
+	zbx_free(value->type);
+	zbx_free(value->id);
+	zbx_vector_uint16_clear(&value->list);
+	zbx_vector_uint16_destroy(&value->list);
+	zbx_free(value);
+}
+
+static int	vmware_uint16_compare(const void *d1, const void *d2)
+{
+	const uint16_t	*i1 = (const uint16_t *)d1;
+	const uint16_t	*i2 = (const uint16_t *)d2;
+
+	ZBX_RETURN_IF_NOT_EQUAL(*i1, *i2);
+
+	return 0;
+}
+
 /******************************************************************************
  *                                                                            *
  * custom query hashset support functions                                     *
@@ -1047,6 +1106,7 @@ static void	vmware_perf_counter_shared_free(zbx_vmware_perf_counter_t *counter)
 {
 	vmware_vector_str_uint64_pair_shared_clean(&counter->values);
 	zbx_vector_str_uint64_pair_destroy(&counter->values);
+	vmware_shared_strfree(counter->query_instance);
 	__vm_shmem_free_func(counter);
 }
 
@@ -1098,7 +1158,10 @@ static void	vmware_entities_shared_clean_stats(zbx_hashset_t *entities)
 			vmware_vector_str_uint64_pair_shared_clean(&counter->values);
 
 			if (0 != (counter->state & ZBX_VMWARE_COUNTER_UPDATING))
-				counter->state = ZBX_VMWARE_COUNTER_READY;
+			{
+				counter->state = ZBX_VMWARE_COUNTER_READY |
+						(counter->state & ZBX_VMWARE_COUNTER_STATE_MASK);
+			}
 		}
 		vmware_shared_strfree(entity->error);
 		entity->error = NULL;
@@ -1115,7 +1178,6 @@ static void	vmware_entities_shared_clean_stats(zbx_hashset_t *entities)
 static void	vmware_diskextent_shared_free(zbx_vmware_diskextent_t *diskextent)
 {
 	vmware_shared_strfree(diskextent->diskname);
-
 	__vm_shmem_free_func(diskextent);
 }
 
@@ -1131,6 +1193,7 @@ static void	vmware_datastore_shared_free(zbx_vmware_datastore_t *datastore)
 	vmware_shared_strfree(datastore->name);
 	vmware_shared_strfree(datastore->id);
 	vmware_shared_strfree(datastore->uuid);
+	vmware_shared_strfree(datastore->type);
 
 	vmware_vector_str_uint64_pair_shared_clean(&datastore->hv_uuids_access);
 	zbx_vector_str_uint64_pair_destroy(&datastore->hv_uuids_access);
@@ -1353,6 +1416,34 @@ static void	vmware_alarm_shared_free(zbx_vmware_alarm_t *alarm)
 	__vm_shmem_free_func(alarm);
 }
 
+/******************************************************************************
+ *                                                                            *
+ * Purpose: frees shared resources allocated to store disk info data          *
+ *                                                                            *
+ * Parameters: di - [IN] the disk info object                                 *
+ *                                                                            *
+ ******************************************************************************/
+static void	vmware_diskinfo_shared_free(zbx_vmware_diskinfo_t *di)
+{
+	vmware_shared_strfree(di->diskname);
+	vmware_shared_strfree(di->ds_uuid);
+	vmware_shared_strfree(di->operational_state);
+	vmware_shared_strfree(di->lun_type);
+	vmware_shared_strfree(di->model);
+	vmware_shared_strfree(di->vendor);
+	vmware_shared_strfree(di->revision);
+	vmware_shared_strfree(di->serial_number);
+
+	if (NULL != di->vsan)
+	{
+		vmware_shared_strfree(di->vsan->ssd);
+		vmware_shared_strfree(di->vsan->local_disk);
+		__vm_shmem_free_func(di->vsan);
+	}
+
+	__vm_shmem_free_func(di);
+}
+
 /******************************************************************************
  *                                                                            *
  * Purpose: frees shared resources allocated to store vmware hypervisor       *
@@ -1374,6 +1465,9 @@ static void	vmware_hv_shared_clean(zbx_vmware_hv_t *hv)
 	zbx_vector_str_clear_ext(&hv->alarm_ids, vmware_shared_strfree);
 	zbx_vector_str_destroy(&hv->alarm_ids);
 
+	zbx_vector_vmware_diskinfo_clear_ext(&hv->diskinfo, vmware_diskinfo_shared_free);
+	zbx_vector_vmware_diskinfo_destroy(&hv->diskinfo);
+
 	if (NULL != hv->uuid)
 		vmware_shared_strfree(hv->uuid);
 
@@ -1416,6 +1510,9 @@ static void	vmware_cluster_shared_free(zbx_vmware_cluster_t *cluster)
 	if (NULL != cluster->status)
 		vmware_shared_strfree(cluster->status);
 
+	zbx_vector_str_clear_ext(&cluster->dss_uuid, vmware_shared_strfree);
+	zbx_vector_str_destroy(&cluster->dss_uuid);
+
 	zbx_vector_str_clear_ext(&cluster->alarm_ids, vmware_shared_strfree);
 	zbx_vector_str_destroy(&cluster->alarm_ids);
 
@@ -1636,9 +1733,14 @@ static zbx_vmware_cluster_t	*vmware_cluster_shared_dup(const zbx_vmware_cluster_
 	cluster->id = vmware_shared_strdup(src->id);
 	cluster->name = vmware_shared_strdup(src->name);
 	cluster->status = vmware_shared_strdup(src->status);
+	VMWARE_VECTOR_CREATE(&cluster->dss_uuid, str);
+	zbx_vector_str_reserve(&cluster->dss_uuid, (size_t)src->dss_uuid.values_num);
 	VMWARE_VECTOR_CREATE(&cluster->alarm_ids, str);
 	zbx_vector_str_reserve(&cluster->alarm_ids, (size_t)src->alarm_ids.values_num);
 
+	for (i = 0; i < src->dss_uuid.values_num; i++)
+		zbx_vector_str_append(&cluster->dss_uuid, vmware_shared_strdup(src->dss_uuid.values[i]));
+
 	for (i = 0; i < src->alarm_ids.values_num; i++)
 		zbx_vector_str_append(&cluster->alarm_ids, vmware_shared_strdup(src->alarm_ids.values[i]));
 
@@ -1680,8 +1782,8 @@ static zbx_vmware_diskextent_t	*vmware_diskextent_shared_dup(const zbx_vmware_di
 	zbx_vmware_diskextent_t	*diskextent;
 
 	diskextent = (zbx_vmware_diskextent_t *)__vm_shmem_malloc_func(NULL, sizeof(zbx_vmware_diskextent_t));
-	diskextent->diskname = vmware_shared_strdup(src->diskname);
 	diskextent->partitionid = src->partitionid;
+	diskextent->diskname = vmware_shared_strdup(src->diskname);
 
 	return diskextent;
 }
@@ -1704,6 +1806,7 @@ static zbx_vmware_datastore_t	*vmware_datastore_shared_dup(const zbx_vmware_data
 	datastore->uuid = vmware_shared_strdup(src->uuid);
 	datastore->name = vmware_shared_strdup(src->name);
 	datastore->id = vmware_shared_strdup(src->id);
+	datastore->type = vmware_shared_strdup(src->type);
 	VMWARE_VECTOR_CREATE(&datastore->hv_uuids_access, str_uint64_pair);
 	zbx_vector_str_uint64_pair_reserve(&datastore->hv_uuids_access, (size_t)src->hv_uuids_access.values_num);
 	VMWARE_VECTOR_CREATE(&datastore->diskextents, vmware_diskextent);
@@ -1974,6 +2077,45 @@ static zbx_vmware_dsname_t	*vmware_dsname_shared_dup(const zbx_vmware_dsname_t *
 	return dsname;
 }
 
+/******************************************************************************
+ *                                                                            *
+ * Purpose: copies vmware hypervisor disks object into shared memory          *
+ *                                                                            *
+ * Parameters: src   - [IN] the vmware disk info object                       *
+ *                                                                            *
+ * Return value: a duplicated vmware disk info object                         *
+ *                                                                            *
+ ******************************************************************************/
+static zbx_vmware_diskinfo_t	*vmware_diskinfo_shared_dup(const zbx_vmware_diskinfo_t *src)
+{
+	zbx_vmware_diskinfo_t	*di;
+
+	di = (zbx_vmware_diskinfo_t *)__vm_shmem_malloc_func(NULL, sizeof(zbx_vmware_diskinfo_t));
+
+	di->diskname = vmware_shared_strdup(src->diskname);
+	di->ds_uuid = vmware_shared_strdup(src->ds_uuid);
+	di->operational_state = vmware_shared_strdup(src->operational_state);
+	di->lun_type = vmware_shared_strdup(src->lun_type);
+	di->queue_depth = src->queue_depth;
+	di->model = vmware_shared_strdup(src->model);
+	di->vendor = vmware_shared_strdup(src->vendor);
+	di->revision = vmware_shared_strdup(src->revision);
+	di->serial_number = vmware_shared_strdup(src->serial_number);
+
+	if (NULL != src->vsan)
+	{
+		di->vsan = (zbx_vmware_vsandiskinfo_t *)__vm_shmem_malloc_func(NULL, sizeof(zbx_vmware_vsandiskinfo_t));
+		di->vsan->ssd = vmware_shared_strdup(src->vsan->ssd);
+		di->vsan->local_disk = vmware_shared_strdup(src->vsan->local_disk);
+		di->vsan->block = src->vsan->block;
+		di->vsan->block_size = src->vsan->block_size;
+	}
+	else
+		di->vsan = NULL;
+
+	return di;
+}
+
 /******************************************************************************
  *                                                                            *
  * Purpose: copies vmware physical NIC object into shared memory              *
@@ -2039,10 +2181,12 @@ static	void	vmware_hv_shared_copy(zbx_vmware_hv_t *dst, const zbx_vmware_hv_t *s
 	VMWARE_VECTOR_CREATE(&dst->vms, ptr);
 	VMWARE_VECTOR_CREATE(&dst->pnics, vmware_pnic);
 	VMWARE_VECTOR_CREATE(&dst->alarm_ids, str);
+	VMWARE_VECTOR_CREATE(&dst->diskinfo, vmware_diskinfo);
 	zbx_vector_vmware_dsname_reserve(&dst->dsnames, (size_t)src->dsnames.values_num);
 	zbx_vector_ptr_reserve(&dst->vms, (size_t)src->vms.values_num);
 	zbx_vector_vmware_pnic_reserve(&dst->pnics, (size_t)src->pnics.values_num);
 	zbx_vector_str_reserve(&dst->alarm_ids, (size_t)src->alarm_ids.values_num);
+	zbx_vector_vmware_diskinfo_reserve(&dst->diskinfo, (size_t)src->diskinfo.values_num);
 
 	dst->uuid = vmware_shared_strdup(src->uuid);
 	dst->id = vmware_shared_strdup(src->id);
@@ -2065,6 +2209,9 @@ static	void	vmware_hv_shared_copy(zbx_vmware_hv_t *dst, const zbx_vmware_hv_t *s
 
 	for (i = 0; i < src->alarm_ids.values_num; i++)
 		zbx_vector_str_append(&dst->alarm_ids, vmware_shared_strdup(src->alarm_ids.values[i]));
+
+	for (i = 0; i < src->diskinfo.values_num; i++)
+		zbx_vector_vmware_diskinfo_append(&dst->diskinfo, vmware_diskinfo_shared_dup(src->diskinfo.values[i]));
 }
 
 /******************************************************************************
@@ -2204,6 +2351,7 @@ static void	vmware_datastore_free(zbx_vmware_datastore_t *datastore)
 	zbx_free(datastore->name);
 	zbx_free(datastore->uuid);
 	zbx_free(datastore->id);
+	zbx_free(datastore->type);
 	zbx_free(datastore);
 }
 
@@ -2358,6 +2506,34 @@ static void	vmware_dsname_free(zbx_vmware_dsname_t *dsname)
 	zbx_free(dsname);
 }
 
+/******************************************************************************
+ *                                                                            *
+ * Purpose: frees resources allocated to store disk info data                 *
+ *                                                                            *
+ * Parameters: di - [IN] the disk info                                        *
+ *                                                                            *
+ ******************************************************************************/
+static void	vmware_diskinfo_free(zbx_vmware_diskinfo_t *di)
+{
+	zbx_free(di->diskname);
+	zbx_free(di->ds_uuid);
+	zbx_free(di->operational_state);
+	zbx_free(di->lun_type);
+	zbx_free(di->model);
+	zbx_free(di->vendor);
+	zbx_free(di->revision);
+	zbx_free(di->serial_number);
+
+	if (NULL != di->vsan)
+	{
+		zbx_free(di->vsan->ssd);
+		zbx_free(di->vsan->local_disk);
+		zbx_free(di->vsan);
+	}
+
+	zbx_free(di);
+}
+
 /******************************************************************************
  *                                                                            *
  * Purpose: frees resources allocated to physical NIC data                    *
@@ -2428,6 +2604,9 @@ static void	vmware_hv_clean(zbx_vmware_hv_t *hv)
 	zbx_vector_str_clear_ext(&hv->alarm_ids, zbx_str_free);
 	zbx_vector_str_destroy(&hv->alarm_ids);
 
+	zbx_vector_vmware_diskinfo_clear_ext(&hv->diskinfo, vmware_diskinfo_free);
+	zbx_vector_vmware_diskinfo_destroy(&hv->diskinfo);
+
 	zbx_free(hv->uuid);
 	zbx_free(hv->id);
 	zbx_free(hv->clusterid);
@@ -2450,6 +2629,8 @@ static void	vmware_cluster_free(zbx_vmware_cluster_t *cluster)
 	zbx_free(cluster->name);
 	zbx_free(cluster->id);
 	zbx_free(cluster->status);
+	zbx_vector_str_clear_ext(&cluster->dss_uuid, zbx_str_free);
+	zbx_vector_str_destroy(&cluster->dss_uuid);
 	zbx_vector_str_clear_ext(&cluster->alarm_ids, zbx_str_free);
 	zbx_vector_str_destroy(&cluster->alarm_ids);
 	zbx_free(cluster);
@@ -3460,31 +3641,27 @@ static int	vmware_service_get_vm_data(zbx_vmware_service_t *service, CURL *easyh
 		"</ns0:RetrievePropertiesEx>"						\
 		ZBX_POST_VSPHERE_FOOTER
 
-	char	tmp[MAX_STRING_LEN + ZBX_VMWARE_VMPROPS_NUM * 100], props[MAX_STRING_LEN], *vmid_esc;
-	int	i, ret = FAIL;
+	char	*tmp, props[ZBX_VMWARE_VMPROPS_NUM * 150], *vmid_esc;
+	int	i, ret;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() vmid:'%s'", __func__, vmid);
 	props[0] = '\0';
 
 	for (i = 0; i < props_num; i++)
 	{
-		zbx_strlcat(props, "<ns0:pathSet>", sizeof(props));
-		zbx_strlcat(props, propmap[i].name, sizeof(props));
-		zbx_strlcat(props, "</ns0:pathSet>", sizeof(props));
+		zbx_strscat(props, "<ns0:pathSet>");
+		zbx_strscat(props, propmap[i].name);
+		zbx_strscat(props, "</ns0:pathSet>");
 	}
 
 	vmid_esc = zbx_xml_escape_dyn(vmid);
-
-	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_VMWARE_VM_STATUS_EX,
+	tmp = zbx_dsprintf(NULL, ZBX_POST_VMWARE_VM_STATUS_EX,
 			vmware_service_objects[service->type].property_collector, props, cq_prop, vmid_esc);
 
 	zbx_free(vmid_esc);
+	ret = zbx_soap_post(__func__, easyhandle, tmp, xdoc, NULL, error);
+	zbx_str_free(tmp);
 
-	if (SUCCEED != zbx_soap_post(__func__, easyhandle, tmp, xdoc, NULL, error))
-		goto out;
-
-	ret = SUCCEED;
-out:
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s", __func__, zbx_result_string(ret));
 
 	return ret;
@@ -3618,6 +3795,7 @@ static void	vmware_vm_snapshot_disksize(xmlDoc *xdoc, const char *key, xmlNode *
  *             uniquesize - [IN/OUT] total uniquesize of all snapshots        *
  *             count      - [IN/OUT] total number of all snapshots            *
  *             latestdate - [OUT] the date of last snapshot                   *
+ *             oldestdate - [OUT] the date of oldest snapshot                 *
  *             json_data  - [OUT] json with info about snapshot               *
  *                                                                            *
  * Return value: SUCCEED - the operation has completed successfully           *
@@ -3626,7 +3804,7 @@ static void	vmware_vm_snapshot_disksize(xmlDoc *xdoc, const char *key, xmlNode *
  ******************************************************************************/
 static int	vmware_vm_snapshot_collect(xmlDoc *xdoc, xmlNode *snap_node, xmlNode *layout_node,
 		zbx_vector_uint64_t *disks_used, zbx_uint64_t *size, zbx_uint64_t *uniquesize, zbx_uint64_t *count,
-		char **latestdate, struct zbx_json *json_data)
+		char **latestdate, char **oldestdate, struct zbx_json *json_data)
 {
 	int			i, ret = FAIL;
 	char			*value, xpath[MAX_STRING_LEN], *name, *desc, *crtime;
@@ -3701,10 +3879,13 @@ static int	vmware_vm_snapshot_collect(xmlDoc *xdoc, xmlNode *snap_node, xmlNode
 	zbx_json_adduint64(json_data, "uniquesize", snap_usize);
 	zbx_json_close(json_data);
 
+	if (NULL != oldestdate)
+		*oldestdate = zbx_strdup(NULL, crtime);
+
 	if (NULL != (next_node = zbx_xml_node_get(xdoc, snap_node, ZBX_XNN("childSnapshotList"))))
 	{
 		ret = vmware_vm_snapshot_collect(xdoc, next_node, layout_node, disks_used, size, uniquesize, count,
-				latestdate, json_data);
+				latestdate, NULL, json_data);
 	}
 	else
 	{
@@ -3742,9 +3923,10 @@ static int	vmware_service_get_vm_snapshot(void *xml_node, char **jstr)
 	xmlDoc			*xdoc = node->doc;
 	struct zbx_json		json_data;
 	int			ret = FAIL;
-	char			*latestdate = NULL;
+	char			*latestdate = NULL, *oldestdate = NULL;
 	zbx_uint64_t		count, size, uniquesize;
 	zbx_vector_uint64_t	disks_used;
+	time_t			xml_time, now = time(NULL), latest_age = 0, oldest_age = 0;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __func__);
 
@@ -3770,14 +3952,23 @@ static int	vmware_service_get_vm_snapshot(void *xml_node, char **jstr)
 	uniquesize = 0;
 
 	if (FAIL == (ret = vmware_vm_snapshot_collect(xdoc, root_node, layout_node, &disks_used, &size, &uniquesize,
-			&count, &latestdate, &json_data)))
+			&count, &latestdate, &oldestdate, &json_data)))
 	{
 		goto out;
 	}
 
+	if (SUCCEED == zbx_iso8601_utc(ZBX_NULL2EMPTY_STR(latestdate), &xml_time))
+		latest_age = now - xml_time;
+
+	if (SUCCEED == zbx_iso8601_utc(ZBX_NULL2EMPTY_STR(oldestdate), &xml_time))
+		oldest_age = now - xml_time;
+
 	zbx_json_close(&json_data);
 	zbx_json_adduint64(&json_data, "count", count);
 	zbx_json_addstring(&json_data, "latestdate", ZBX_NULL2EMPTY_STR(latestdate), ZBX_JSON_TYPE_STRING);
+	zbx_json_addint64(&json_data, "latestage", latest_age);
+	zbx_json_addstring(&json_data, "oldestdate", ZBX_NULL2EMPTY_STR(oldestdate), ZBX_JSON_TYPE_STRING);
+	zbx_json_addint64(&json_data, "oldestage", oldest_age);
 	zbx_json_adduint64(&json_data, "size", size);
 	zbx_json_adduint64(&json_data, "uniquesize", uniquesize);
 	zbx_json_close(&json_data);
@@ -4103,11 +4294,11 @@ static zbx_vmware_vm_t	*vmware_service_create_vm(zbx_vmware_service_t *service,
 		zbx_vmware_alarms_data_t *alarms_data, char **error)
 {
 	zbx_vmware_vm_t		*vm;
-	char			*value, buff[MAX_STRING_LEN];
+	char			*value, *cq_prop;
 	xmlDoc			*details = NULL;
-	zbx_vmware_cq_value_t	*cqv;
+	zbx_vector_cq_value_t	cqvs;
 	const char		*uuid_xpath[3] = {NULL, ZBX_XPATH_VM_UUID(), ZBX_XPATH_VM_INSTANCE_UUID()};
-	int			ret = FAIL;
+	int			ret;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() vmid:'%s'", __func__, id);
 
@@ -4117,16 +4308,20 @@ static zbx_vmware_vm_t	*vmware_service_create_vm(zbx_vmware_service_t *service,
 	zbx_vector_ptr_create(&vm->devs);
 	zbx_vector_ptr_create(&vm->file_systems);
 	zbx_vector_vmware_custom_attr_create(&vm->custom_attrs);
+	zbx_vector_cq_value_create(&cqvs);
+	cq_prop = vmware_cq_prop_soap_request(cq_values, ZBX_VMWARE_SOAP_VM, id, &cqvs);
+	ret = vmware_service_get_vm_data(service, easyhandle, id, vm_propmap, ZBX_VMWARE_VMPROPS_NUM, cq_prop,
+			&details, error);
+	zbx_str_free(cq_prop);
 
-	if (SUCCEED != vmware_service_get_vm_data(service, easyhandle, id, vm_propmap, ZBX_VMWARE_VMPROPS_NUM,
-			vmware_cq_prop_soap_request(cq_values, ZBX_VMWARE_SOAP_VM, id, sizeof(buff), buff, &cqv),
-			&details, error))
-	{
+	if (FAIL == ret)
 		goto out;
-	}
 
 	if (NULL == (value = zbx_xml_doc_read_value(details, uuid_xpath[service->type])))
+	{
+		ret = FAIL;
 		goto out;
+	}
 
 	vm->uuid = value;
 	vm->id = zbx_strdup(NULL, id);
@@ -4177,13 +4372,14 @@ static zbx_vmware_vm_t	*vmware_service_create_vm(zbx_vmware_service_t *service,
 	vmware_vm_get_file_systems(vm, details);
 	vmware_vm_get_custom_attrs(vm, details);
 
-	if (NULL != cqv)
-		vmware_service_cq_prop_value(__func__, details, cqv);
+	if (0 != cqvs.values_num)
+		vmware_service_cq_prop_value(__func__, details, &cqvs);
 
 	zbx_vector_str_create(&vm->alarm_ids);
 	ret = vmware_service_get_alarms_data(__func__, service, easyhandle, details, NULL, &vm->alarm_ids, alarms_data,
 			error);
 out:
+	zbx_vector_cq_value_destroy(&cqvs);
 	zbx_xml_free_doc(details);
 
 	if (SUCCEED != ret)
@@ -4249,8 +4445,6 @@ static int	vmware_service_get_diskextents_list(xmlDoc *doc, zbx_vector_vmware_di
 	xmlXPathContext		*xpathCtx;
 	xmlXPathObject		*xpathObj;
 	xmlNodeSetPtr		nodeset;
-	char			*name, *partition;
-	zbx_vmware_diskextent_t	*diskextent;
 	int			i, ret = FAIL;
 
 	if (NULL == doc)
@@ -4268,19 +4462,23 @@ static int	vmware_service_get_diskextents_list(xmlDoc *doc, zbx_vector_vmware_di
 
 	for (i = 0; i < nodeset->nodeNr; i++)
 	{
-		if (NULL == (name = zbx_xml_node_read_value(doc, nodeset->nodeTab[i], ZBX_XPATH_NN("diskName"))))
+		char			*value;
+		zbx_vmware_diskextent_t	*diskextent;
+		xmlNode			*xn = nodeset->nodeTab[i];
+
+		if (NULL == (value = zbx_xml_node_read_value(doc, xn, ZBX_XPATH_NN("diskName"))))
 		{
 			zabbix_log(LOG_LEVEL_DEBUG, "%s(): Cannot get diskName.", __func__);
 			continue;
 		}
 
 		diskextent = (zbx_vmware_diskextent_t *)zbx_malloc(NULL, sizeof(zbx_vmware_diskextent_t));
-		diskextent->diskname = name;
+		diskextent->diskname = value;
 
-		if (NULL != (partition = zbx_xml_node_read_value(doc, nodeset->nodeTab[i], ZBX_XPATH_NN("partition"))))
+		if (NULL != (value = zbx_xml_node_read_value(doc, xn, ZBX_XPATH_NN("partition"))))
 		{
-			diskextent->partitionid = (unsigned int) atoi(partition);
-			zbx_free(partition);
+			diskextent->partitionid = (unsigned int) atoi(value);
+			zbx_free(value);
 		}
 		else
 			diskextent->partitionid = 0;
@@ -4288,7 +4486,7 @@ static int	vmware_service_get_diskextents_list(xmlDoc *doc, zbx_vector_vmware_di
 		zbx_vector_vmware_diskextent_append(diskextents, diskextent);
 	}
 
-	zbx_vector_vmware_diskextent_sort(diskextents, ZBX_DEFAULT_UINT64_PTR_COMPARE_FUNC);
+	zbx_vector_vmware_diskextent_sort(diskextents, ZBX_DEFAULT_STR_PTR_COMPARE_FUNC);
 
 	ret = SUCCEED;
 out:
@@ -4335,15 +4533,16 @@ static zbx_vmware_datastore_t	*vmware_service_create_datastore(const zbx_vmware_
 		"</ns0:RetrievePropertiesEx>"							\
 		ZBX_POST_VSPHERE_FOOTER
 
-	char			tmp[MAX_STRING_LEN], buff[MAX_STRING_LEN], *uuid = NULL, *name = NULL, *path, *id_esc,
-				*value, *error = NULL;
+	char			*tmp, *cq_prop, *uuid = NULL, *name = NULL, *path, *id_esc, *value, *error = NULL;
+	int			ret;
 	zbx_vmware_datastore_t	*datastore = NULL;
 	zbx_uint64_t		capacity = ZBX_MAX_UINT64, free_space = ZBX_MAX_UINT64, uncommitted = ZBX_MAX_UINT64;
 	xmlDoc			*doc = NULL;
-	zbx_vmware_cq_value_t	*cqv;
+	zbx_vector_cq_value_t	cqvs;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() datastore:'%s'", __func__, id);
 
+	zbx_vector_cq_value_create(&cqvs);
 	id_esc = zbx_xml_escape_dyn(id);
 
 	if (ZBX_VMWARE_TYPE_VSPHERE == service->type && NULL != service->version &&
@@ -4354,14 +4553,16 @@ static zbx_vmware_datastore_t	*vmware_service_create_datastore(const zbx_vmware_
 		goto out;
 	}
 
-	zbx_snprintf(tmp, sizeof(tmp), ZBX_POST_DATASTORE_GET,
-			vmware_service_objects[service->type].property_collector,
-			vmware_cq_prop_soap_request(cq_values, ZBX_VMWARE_SOAP_DS, id, sizeof(buff), buff, &cqv),
-			id_esc);
 
-	zbx_free(id_esc);
+	cq_prop = vmware_cq_prop_soap_request(cq_values, ZBX_VMWARE_SOAP_DS, id, &cqvs);
+	tmp = zbx_dsprintf(NULL, ZBX_POST_DATASTORE_GET, vmware_service_objects[service->type].property_collector,
+			cq_prop, id_esc);
+	zbx_str_free(id_esc);
+	zbx_str_free(cq_prop);
+	ret = zbx_soap_post(__func__, easyhandle, tmp, &doc, NULL, &error);
+	zbx_str_free(tmp);
 
-	if (SUCCEED != zbx_soap_post(__func__, easyhandle, tmp, &doc, NULL, &error))
+	if (FAIL == ret)
 		goto out;
 
 	name = zbx_xml_doc_read_value(doc, ZBX_XPATH_DATASTORE_SUMMARY("name"));
@@ -4378,7 +4579,7 @@ static zbx_vmware_datastore_t	*vmware_service_create_datastore(const zbx_vmware_
 			if ('/' == path[len - 1])
 				path[len - 1] = '\0';
 
-			for (ptr = path + len - 2; ptr > path && *ptr != '/'; ptr--)
+			for (ptr = path + len - 2; ptr > path && *ptr != '/' && *ptr != ':'; ptr--)
 				;
 
 			uuid = zbx_strdup(NULL, ptr + 1);
@@ -4417,6 +4618,7 @@ static zbx_vmware_datastore_t	*vmware_service_create_datastore(const zbx_vmware_
 	datastore->name = (NULL != name) ? name : zbx_strdup(NULL, id);
 	datastore->uuid = uuid;
 	datastore->id = zbx_strdup(NULL, id);
+	datastore->type = zbx_xml_doc_read_value(doc, ZBX_XPATH_DATASTORE_SUMMARY("type"));
 	datastore->capacity = capacity;
 	datastore->free_space = free_space;
 	datastore->uncommitted = uncommitted;
@@ -4425,8 +4627,8 @@ static zbx_vmware_datastore_t	*vmware_service_create_datastore(const zbx_vmware_
 	zbx_vector_vmware_diskextent_create(&datastore->diskextents);
 	vmware_service_get_diskextents_list(doc, &datastore->diskextents);
 
-	if (NULL != cqv)
-		vmware_service_cq_prop_value(__func__, doc, cqv);
+	if (0 != cqvs.values_num)
+		vmware_service_cq_prop_value(__func__, doc, &cqvs);
 
 	if (FAIL == vmware_service_get_alarms_data(__func__, service, easyhandle, doc, NULL, &datastore->alarm_ids,
 			alarms_data, &error))
@@ -4436,6 +4638,7 @@ static zbx_vmware_datastore_t	*vmware_service_create_datastore(const zbx_vmware_
 	}
 out:
 	zbx_xml_free_doc(doc);
+	zbx_vector_cq_value_destroy(&cqvs);
 
 	if (NULL != error)
 	{
@@ -4496,7 +4699,7 @@ static int	vmware_service_get_hv_data(const zbx_vmware_service_t *service, CURL
 		"</ns0:RetrievePropertiesEx>"									\
 		ZBX_POST_VSPHERE_FOOTER
 
-	char	tmp[MAX_STRING_LEN + ZBX_VMWARE_HVPROPS_NUM * 100], props[MAX_STRING_LEN], *hvid_esc;
+	char	*tmp, props[ZBX_VMWARE_HVPROPS_NUM * 150], *hvid_esc;
 	int	i, ret = FAIL;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s() guesthvid:'%s'", __func__, hvid);
